/*
Zarafa Mail Checker
Copyright (C) 2007 Michael Erkens

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

var ZarafaSettings = new Object();

ZarafaSettings.init = function()
{
	this.settings = null;
	this.callers = new Array();

	var xml = '<zarafa><module name="settingsmodule" id="firefox_3"><action type="retrieveAll"></action></module></zarafa>';
	this.request = new XMLHttpRequest();
	this.request.open("POST", ZarafaPrefs.get("server_url")+"/zarafa.php?subsystem=firefox&external="+ZarafaPrefs.get("server_cookie"), true);
	this.request.setRequestHeader("Content-Type", "text/xml;charset=utf-8;");
	this.request.onload = ZarafaSettings.onXMLResponse;
	this.request.send(xml);
}

ZarafaSettings.onXMLResponse = function()
{
	ZarafaSettings.settings = ZarafaSettings.request.responseXML.getElementsByTagName("action")[0];

	for(var i=0;i<ZarafaSettings.callers.length;i++)
	{
		ZarafaSettings.callers[i]();
	}
	ZarafaSettings.callers = new Array();
}

ZarafaSettings.callWhenReady = function(handler)
{
	if (this.settings != null)
	{
		handler();
		return;
	}

	this.callers.push(handler);	
}

ZarafaSettings.get = function(key, tree)
{
	var result = null;
	var keys = key.split("/");
	var first = keys.splice(0,1);
	var rest = keys.join("/");

	if (typeof tree == "undefined")
		tree = this.settings;
	
	if (rest.length>0){
		var setting = tree.getElementsByTagName(first);
		if (setting[0]){
			result = this.get(rest, setting[0]);
		}
	}else{
		result = Zarafa.getXMLValue(tree, first, null);
	}
	return result;
}
